/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package du2;

import du1.Byt;
import du1.Dum;
import du1.IRealitniKancelar;
import du1.Nemovitost;
import du1.Pozemek;
import du1.RealitniKancelar;
import du1.Vlastnictvi;
import du3.RealitniKancelarDB;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author Ing. Jaroslav Kuchař <kuchajar at fel.cvut.cz>
 */
public class HlavniOkno extends JFrame {

    private IRealitniKancelar realitka = new RealitniKancelarDB();
    private JTable table;
    private JMenuBar menuBar;
    private JMenu menu;
    private JMenuItem dum, pozemek, byt;

    public HlavniOkno() {
        super("Realitni kancelar");
        setDefaultCloseOperation(EXIT_ON_CLOSE);

        /*
        // testovaci startovni databaze
        realitka.vloz(new Byt("nazev bytu1", "adresa1", 60, 1E6, 4, Vlastnictvi.OSOBNI));
        realitka.vloz(new Byt("nazev bytu2", "adresa2", 60, 1E6, 4, Vlastnictvi.OSTATNI));
        realitka.vloz(new Byt("nazev bytu3", "adresa3", 60, 3E6, 6, Vlastnictvi.DRUZSTEVNI));
        realitka.vloz(new Pozemek("pozemek", "poz adr", 15E3, 1.5E6, Vlastnictvi.OSOBNI));
        realitka.vloz(new Dum("Dum", "Dum adresa", 300, 5E6, 234, 6, Vlastnictvi.OSOBNI));
         *
         */
        menuBar = new JMenuBar();
        menu = new JMenu("Novy");
        menuBar.add(menu);
        byt = new JMenuItem("Byt");
        byt.addActionListener(new MenuListener());
        pozemek = new JMenuItem("Pozemek");
        pozemek.addActionListener(new MenuListener());
        dum = new JMenuItem("Dum");
        dum.addActionListener(new MenuListener());
        menu.add(byt);
        menu.add(pozemek);
        menu.add(dum);
        setJMenuBar(menuBar);

        table = new JTable(new MyTableModel());
        table.setPreferredScrollableViewportSize(new Dimension(500, 500));
        table.setFillsViewportHeight(true);
        //table.getSelectionModel().addListSelectionListener(new RowListener());
        table.addMouseListener(new MouseClickListener());

        JScrollPane scrollPane = new JScrollPane(table);
        add(scrollPane);

        pack();
    }

    private class MenuListener implements ActionListener {

        // reakce na stisknuti tlacitka z menu
        public void actionPerformed(ActionEvent e) {
            // pro kazdy typ se vytvori novy objekt s inicializaci hodnot
            if (e.getSource().equals(dum)) {
                new Dialog(realitka, new Dum("", "", 0, 0, 0, 0, Vlastnictvi.OSOBNI), table).setVisible(true);
            }
            if (e.getSource().equals(byt)) {
                new Dialog(realitka, new Byt("", "", 0, 0, 0, Vlastnictvi.OSOBNI), table).setVisible(true);
            }
            if (e.getSource().equals(pozemek)) {
                new Dialog(realitka, new Pozemek("", "", 0, 0, Vlastnictvi.OSOBNI), table).setVisible(true);
            }
        }
    }

    private class MouseClickListener implements MouseListener {

        private final int DOUBLE_CLICK = 2;

        public void mouseClicked(MouseEvent e) {
            if (e.getClickCount() == DOUBLE_CLICK) {
                new Dialog(realitka, table.getSelectedRow(), table).setVisible(true);
            }
        }

        public void mousePressed(MouseEvent e) {
        }

        public void mouseReleased(MouseEvent e) {
        }

        public void mouseEntered(MouseEvent e) {
        }

        public void mouseExited(MouseEvent e) {
        }
    }

    // reakce na zmenu vybraneho radku = otevreni dialogu
    private class RowListener implements ListSelectionListener {

        public void valueChanged(ListSelectionEvent event) {
            if (event.getValueIsAdjusting()) {
                return;
            }
            new Dialog(realitka, table.getSelectedRow(), table).setVisible(true);

        }
    }

    // table model s daty
    private class MyTableModel extends AbstractTableModel {

        private final int POCET_SLOUPECKU = 8;
        private final String[] NAZVY_SLOUPECKU = {"Typ", "Nazev", "Adresa", "Cena", "Plocha", "Vlastnictvi", "Rezervovat", "Prodat"};

        public int getRowCount() {
            return realitka.vratSeznam().size();
        }

        public int getColumnCount() {
            return POCET_SLOUPECKU;
        }

        @Override
        public String getColumnName(int col) {
            return NAZVY_SLOUPECKU[col];
        }

        @Override
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        @Override
        public boolean isCellEditable(int row, int col) {
            if (col < 6) {
                return false;
            } else {
                return true;
            }
        }

        @Override
        public void setValueAt(Object value, int row, int col) {
            if (!realitka.vrat(row).isProdano()) {
                if (col == 6) {
                    realitka.vrat(row).setRezervovano((Boolean) value);
                    realitka.uprav(realitka.vrat(row), row);
                    fireTableCellUpdated(row, col);
                }
                if (col == 7) {
                    realitka.vrat(row).setProdano((Boolean) value);
                    realitka.vrat(row).setRezervovano((Boolean) value);
                    realitka.uprav(realitka.vrat(row), row);
                    fireTableCellUpdated(row, col);
                    fireTableCellUpdated(row, col - 1);
                }
            }


        }

        public Object getValueAt(int rowIndex, int columnIndex) {
            Nemovitost nemovitost = realitka.vrat(rowIndex);
            switch (columnIndex) {
                case 0:
                    return nemovitost.getClass().getSimpleName();
                case 1:
                    return nemovitost.getNazev();
                case 2:
                    return nemovitost.getAdresa();
                case 3:
                    return nemovitost.getCena();
                case 4:
                    return nemovitost.getPlocha();
                case 5:
                    return nemovitost.getVlastnictvi();
                case 6:
                    return nemovitost.isRezervovano();
                case 7:
                    return nemovitost.isProdano();
                default:
                    return "Mimo rozsah";
            }

        }
    }

    public static void main(String[] args) throws Exception {
        try {
            SwingUtilities.invokeLater(new Runnable() {

                public void run() {
                    new HlavniOkno().setVisible(true);
                }
            });
        } catch (Exception e) {
            JOptionPane.showMessageDialog(new JFrame(), e.toString(), "Chyba", JOptionPane.ERROR_MESSAGE);
            throw e;
        }
    }
}
