package du3;

import du1.Byt;
import du1.Dum;
import du1.IRealitniKancelar;
import du1.Nemovitost;
import du1.Pozemek;
import du1.Vlastnictvi;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Ing. Jaroslav Kuchař
 */
public class RealitniKancelarDB implements IRealitniKancelar {

    //String url = "jdbc:derby://localhost:1527/kuchajar";
    String url = "jdbc:derby:kuchajar;create=true";
    String user = "kuchajar";
    String password = "kuchajar";
    Connection conn;
    List seznam;

    public RealitniKancelarDB() {
        try {
            //Class.forName("org.apache.derby.jdbc.ClientDriver").newInstance();
            Class.forName("org.apache.derby.jdbc.EmbeddedDriver").newInstance();
            conn = DriverManager.getConnection(url, user, password);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        createDB();
    }

    public void createDB() {
        try {
            Statement st = conn.createStatement();
            st.execute("CREATE TABLE APP.NEMOVITOST("
                    + "ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1) PRIMARY KEY,"
                    + "NAZEV VARCHAR(100),"
                    + "ADRESA VARCHAR(200),"
                    + "PLOCHA DOUBLE,"
                    + "CENA DOUBLE,"
                    + "VLASTNICTVI INTEGER,"
                    + "POCETMISTNOSTI INTEGER,"
                    + "CENAZAM2 DOUBLE,"
                    + "TYP INTEGER,"
                    + "PRODANO INTEGER,"
                    + "REZERVOVANO INTEGER"
                    + ")");
            st.close();
        } catch (SQLException e) {
            //e.printStackTrace();
        }

    }

    public String getNazev() {
        return "DB Realitka";
    }

    public String getAdresa() {
        return "DB adresa";
    }

    public void vypis() {
        System.out.println("DB vypis");
    }

    public void vloz(Nemovitost n) {
        try {
            PreparedStatement st = conn.prepareStatement("INSERT INTO APP.NEMOVITOST (nazev,adresa,plocha,cena,vlastnictvi,pocetmistnosti,cenazam2,typ,prodano,rezervovano) VALUES (?,?,?,?,?,?,?,?,?,?)");
            st.setString(1, n.getNazev());
            st.setString(2, n.getAdresa());
            st.setDouble(3, n.getPlocha());
            st.setDouble(4, n.getCena());
            st.setInt(5, n.getVlastnictvi().ordinal());
            if (n instanceof Byt) {
                Byt b = (Byt) n;
                st.setInt(6, b.getPocetMistnosti());
                st.setDouble(7, 0);
                st.setInt(8, 1);
            }
            if (n instanceof Pozemek) {
                Pozemek b = (Pozemek) n;
                st.setInt(6, 0);
                st.setDouble(7, b.getCenaZaM2());
                st.setInt(8, 2);
            }
            if (n instanceof Dum) {
                Dum b = (Dum) n;
                st.setInt(6, b.getPocetMistnosti());
                st.setDouble(7, b.getCenaZaM2());
                st.setInt(8, 3);
            }
            st.setBoolean(9, false);
            st.setBoolean(10, false);

            st.executeUpdate();
            st.close();

        } catch (SQLException ex) {
            ex.printStackTrace();
        }

    }

    public void smaz(Nemovitost n) {
        try {
            PreparedStatement st = conn.prepareStatement("DELETE FROM APP.Nemovitost WHERE Id=?");
            st.setInt(1, n.getId());
            st.executeUpdate();
            st.close();
        } catch (SQLException ex) {
            ex.printStackTrace();
        }

    }

    public Nemovitost vrat(int i) {
        return (Nemovitost) seznam.get(i);
    }

    public void uprav(Nemovitost n, int i) {
        try {
            PreparedStatement st = conn.prepareStatement("UPDATE APP.Nemovitost SET prodano = ?, rezervovano = ? WHERE Id=?");
            st.setBoolean(1, n.isProdano());
            st.setBoolean(2, n.isRezervovano());
            st.setInt(3, n.getId());
            st.executeUpdate();
            st.close();

        } catch (SQLException ex) {
            ex.printStackTrace();
        }
    }

    public List<Nemovitost> vratSeznam() {
        seznam = new ArrayList();
        Nemovitost n;
        try {

            Statement st = conn.createStatement();
            ResultSet rs = st.executeQuery("SELECT * FROM APP.Nemovitost");
            while (rs.next()) {
                switch (rs.getInt("TYP")) {
                    case 1:
                        n = new Byt(rs.getString("NAZEV"), rs.getString("ADRESA"), rs.getDouble("PLOCHA"), rs.getDouble("CENA"), rs.getInt("POCETMISTNOSTI"), Vlastnictvi.fromId(rs.getInt("VLASTNICTVI")));
                        n.setId(rs.getInt("ID"));
                        n.setProdano(rs.getBoolean("PRODANO"));
                        n.setRezervovano(rs.getBoolean("REZERVOVANO"));
                        seznam.add(n);
                        break;
                    case 2:
                        n = new Pozemek(rs.getString("NAZEV"), rs.getString("ADRESA"), rs.getDouble("PLOCHA"), rs.getDouble("CENA"), Vlastnictvi.fromId(rs.getInt("VLASTNICTVI")));
                        n.setId(rs.getInt("ID"));
                        n.setProdano(rs.getBoolean("PRODANO"));
                        n.setRezervovano(rs.getBoolean("REZERVOVANO"));
                        seznam.add(n);
                        break;
                    case 3:
                        n = new Dum(rs.getString("NAZEV"), rs.getString("ADRESA"), rs.getDouble("PLOCHA"), rs.getDouble("CENA"), rs.getDouble("CENAZAM2"), rs.getInt("POCETMISTNOSTI"), Vlastnictvi.fromId(rs.getInt("VLASTNICVI")));
                        n.setId(rs.getInt("ID"));
                        n.setProdano(rs.getBoolean("PRODANO"));
                        n.setRezervovano(rs.getBoolean("REZERVOVANO"));
                        seznam.add(n);
                        break;
                }
            }
            st.close();

        } catch (SQLException ex) {
            ex.printStackTrace();
        }
        return seznam;
    }

    @Override
    protected void finalize() throws Throwable {
        conn.close();
    }
}
